/*weapons.h  Copyright (c) 2015, Ross Driedger All Rights Reserved.*/

#if !defined(WEAPONS_H__)
#define WEAPONS_H__

class Weapon
{
public:
    virtual void use() = 0;
    virtual ~Weapon();
};

class RangeWeapon: public Weapon
{
public:
    virtual void use();
    virtual ~RangeWeapon();
};

class ChargeWeapon: public Weapon
{
public:
    virtual void use();
    virtual ~ChargeWeapon();
};


class MeleeWeapon: public Weapon
{
public:
    virtual void use();
    virtual ~MeleeWeapon();
};


class BallisticWeapon: public Weapon
{
public:
    virtual void use();
    virtual ~BallisticWeapon();
};

class M777_Howitzer: public RangeWeapon
{
public:
    virtual void use();
    virtual ~M777_Howitzer();
};

class AK47: public RangeWeapon
{
public:
    virtual void use();
    virtual ~AK47();
};

class Taser: public ChargeWeapon
{
public:
    virtual void use();
    virtual ~Taser();
};

class BFG9000: public ChargeWeapon
{
public:
    virtual void use();
    virtual ~BFG9000();
};

class BowieKnife: public MeleeWeapon
{
public:
    virtual void use();
    virtual ~BowieKnife();
};

class PointyStick: public MeleeWeapon
{
public:
    virtual void use();
    virtual ~PointyStick();
};

class ICBM: public BallisticWeapon
{
public:
    virtual void use();
    virtual ~ICBM();
};

#endif
